<?php
/**
  RedBean_Driver_OCI
  @author			Gabor de Mooij
  @license			BSD
  (c) G.J.G.T. (Gabor) de Mooij
  This source file is subject to the BSD
 
 Copyright (c) 2011, Gabor de Mooij
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
*/
class RedBean_Driver_OCI implements RedBean_Driver { 

	private $dsn;

	/**
	 * 
	 * @var unknown_type
	 */
	private static $instance;
    
	/**
	 * 
	 * @var boolean
	 */
    private $debug = false;
    
    /**
     * 
     * @var unknown_type
     */
    private $pdo;
    
    /**
     * 
     * @var unknown_type
     */
    private $affected_rows;
    
    /**
     * 
     * @var unknown_type
     */
    private $rs;
    
    /**
     * 
     * @var unknown_type
     */
    private $exc =0;

    private $autocommit = true;


    /**
     * Returns an instance of the PDO Driver.
     * @param $dsn
     * @param $user
     * @param $pass
     * @param $dbname
     * @return unknown_type
     */
    public static function getInstance($dsn, $user, $pass, $dbname)
    {
        if(is_null(self::$instance))
        {
            self::$instance = new RedBean_Driver_OCI($dbname, $user, $pass);
            
        }
        return self::$instance;
    }
    


    /**
     * Constructor.
     * @param $dsn
     * @param $user
     * @param $pass
     * @return unknown_type
     */
    public function __construct($db, $user, $pass)
    {
	echo "$user, $pass, $db";
	$conn = oci_connect($user, $pass, $db);
	$this->connection = $conn;


    }

    public function setAutoCommit( $toggle ) {
       $this->autocommit = (bool) $toggle;
    }	

    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetAll()
     */
    public function GetAll( $sql, $aValues=array() )
    {
	$stid = $this->Execute($sql, $aValues);
      
	  $rows = array();
	while($rs=oci_fetch_assoc($stid)) $rows[]=$rs;
        return $rows;
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetCol()
     */
    public function GetCol($sql, $aValues=array())
    {
    	
		$rows = $this->GetAll($sql,$aValues);
		$cols = array();

		if ($rows && is_array($rows) && count($rows)>0){
			foreach ($rows as $row)
			{
				$cols[] = array_shift($row);
			}
		}

        return $cols;
    }
 
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetCell()
     */
    public function GetCell($sql, $aValues=array())
    {
    	
        $arr = $this->GetAll($sql,$aValues);
	    $row1 = array_shift($arr);
	    $col1 = array_shift($row1);
        return $col1;
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetRow()
     */
    public function GetRow($sql, $aValues=array())
    {
    	
       	$arr = $this->GetAll($sql, $aValues);
        return array_shift($arr);
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#ErrorNo()
     */
    public function ErrorNo()
    {
    	
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#Errormsg()
     */
    public function Errormsg()
    {
    	
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#Execute()
     */
    public function Execute( $sql, $aValues=array() )
    {

	$stid = oci_parse($this->connection, $sql);
	foreach($aValues as $key=>$value) {
		    $tf =oci_bind_by_name($stid,$key,$aValues[$key]);
	}

	$returnID = -1;
        if (strpos($sql,":retid")!==false) {
		oci_bind_by_name($stid, ":retid", $returnID );
        }
        
	oci_execute($stid);
	if ($returnID>-1) return $returnID; else return $stid;
		
    }

    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#Escape()
     */
    public function Escape( $str )
    {
        return $str;
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetInsertID()
     */
    public function GetInsertID()
    {
        return 0;
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#Affected_Rows()
     */
    public function Affected_Rows()
    {
        return 0;
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#setDebugMode()
     */
    public function setDebugMode( $tf )
    {
        
    }
    
    /**
     * (non-PHPdoc)
     * @see RedBean/RedBean_Driver#GetRaw()
     */
    public function GetRaw()
    {
        //return $this->rs;
    }


	/**
	 * Starts a transaction.
	 */
	public function StartTrans() {
		
	}

	/**
	 * Commits a transaction.
	 */
	public function CommitTrans() {
		oci_commit($this->connection);
	}


	/**
	 * Rolls back a transaction.
	 */
	public function FailTrans() {
		oci_rollback($this->connection);
	}

	/**
	 * Returns the name of the database type/brand: i.e. mysql, db2 etc.
	 * @return string $typeName
	 */
	public function getDatabaseType() {
		return "OCI";
	}

	/**
	 * Returns the version number of the database.
	 * @return mixed $version 
	 */
	public function getDatabaseVersion() {
		return "8";
	}

}



class RedBean_QueryWriter_OCI extends RedBean_IceWriter_AIceWriter implements RedBean_IceWriter {

	protected $idfield = "ID";

	public function __construct( RedBean_Adapter $adapter, $frozen = false ) {
		$this->adapter = $adapter;
	}
	/**
	 * Update a record using a series of update values.
	 *
	 * @param string  $table		  table
	 * @param array   $updatevalues update values
	 * @param integer $id			  primary key for record
	 */
	public function updateRecord( $table, $updatevalues, $id) {
		if (!$id) {
			$insertcolumns =  $insertvalues = array();
			foreach($updatevalues as $pair) {
				$insertcolumns[] = $pair["property"];
				$insertvalues[] = $pair["value"];
			}
			return $this->insertRecord($table,$insertcolumns,array($insertvalues));
		}
		if ($id && !count($updatevalues)) return $id;
		$idfield = $this->getIDField($table, true);
		$table = $this->safeTable($table);
		$sql = "UPDATE $table SET ";
		$p = $v = array();
		$slotCounter = 0;

		foreach($updatevalues as $uv) {
			$p[] = " {$this->safeColumn($uv["property"])} = :slot".($slotCounter)." ";
			
			$v[":slot".$slotCounter]=$uv["value"];
			$slotCounter++;
		}
		$sql .= implode(",", $p ) ." WHERE $idfield = ".intval($id);
		$this->adapter->exec( $sql, $v );
		return $id;
	}
	/**
	 * Inserts a record into the database using a series of insert columns
	 * and corresponding insertvalues. Returns the insert id.
	 *
	 * @param string $table			  table to perform query on
	 * @param array  $insertcolumns columns to be inserted
	 * @param array  $insertvalues  values to be inserted
	 *
	 * @return integer $insertid	  insert id from driver, new record id
	 */
	protected function insertRecord( $table, $insertcolumns, $insertvalues ) {
		$default = $this->defaultValue;
		$idfield = $this->getIDField($table, true);
		$suffix = "returning id into :retid "; //$this->getInsertSuffix($table);
		$table = $this->safeTable($table);
		if (count($insertvalues)>0 && is_array($insertvalues[0]) && count($insertvalues[0])>0) {
			$slots=array();
			foreach($insertcolumns as $k=>$v) {
				$insertcolumns[$k] = $this->safeColumn($v);
				$slots[] = ":$v";
			}
			$insertSQL = "INSERT INTO $table ( $idfield, ".implode(",",$insertcolumns)." ) VALUES ";
                        
			$insertSQL .= "( $default, ". implode(",",$slots)." ) $suffix";
			$first=true;
			
			foreach($insertvalues as $i=>$insertvalue) {
				$insertvalue = array_combine($slots,$insertvalue);



				$ids[] = $this->adapter->exec( $insertSQL, $insertvalue, $i );
			}
			$result = count($ids)===1 ? array_pop($ids) : $ids;
		}
		else {
			$result = $this->adapter->exec( "INSERT INTO $table ($idfield) VALUES($default) $suffix ;");
		}
		return $result;
	}
	
	


	public function selectRecord( $type, $conditions, $addSql=null, $delete=null, $inverse=false ) {
		if (!is_array($conditions)) throw new Exception("Conditions must be an array");
		
		$slotCounter = 0;
		$table = $this->safeTable($type);
		$sqlConditions = array();
		$bindings=array();
		foreach($conditions as $column=>$values) {
			$sql = $this->safeColumn($column);
			$sql .= " ".($inverse ? " NOT ":"")." IN ( ";
			if (!is_array($values)) throw new Exception("Values must be an array");
			$slotLabels = array();
			$numOfSlots = count($values);	
			for($i=0; $i<$numOfSlots; $i++) {
				$slotCounter ++;
				$slotLabel = ":slot$slotCounter";
				$slotLabels[] = $slotLabel; 
				$v = strval( array_shift($values) );
				$bindings[$slotLabel]=$v;
			}
			$sql .= implode(",",$slotLabels)." ) ";	

			$sqlConditions[] = $sql;
			
		}
		
		if (is_array($addSql)) {
			foreach($addSql[1] as $k=>$v){
				$bindings[$k]=$v;
			}
			$addSql = $addSql[0];
		}
		$sql="";
		if (count($sqlConditions)>0) {
			$sql = implode(" AND ",$sqlConditions);
			$sql = " WHERE ( $sql ) ";
			if ($addSql) $sql .= " AND $addSql ";
		}
		elseif ($addSql) {
			$sql = " WHERE ".$addSql;
		}
		$sql = (($delete) ? "DELETE FROM " : "SELECT * FROM ").$table.$sql;
		$rows = $this->adapter->get($sql,$bindings);
		return $rows;
	}
	public function count($beanType) {
		$table = $this->safeTable($beanType);
		$sql = "SELECT count(*) FROM $table ";
		return (int) $this->adapter->getCell($sql);
	}


	
}
/** USAGE EXAMPLE 
$driver = RedBean_Driver_OCI::getInstance("oci","xdev","xdev","localhost/XE");
$adapter = new RedBean_Adapter_DBAdapter( $driver );
$writer = new RedBean_QueryWriter_OCI( $adapter );
$redbean = new RedBean_OODB( $writer );
$toolbox = new RedBean_CoolBox( $redbean, $adapter, $writer );

//regular table read/write
$redbean->freeze( true );
$book = $redbean->dispense("book");

$book->TITLE = "Harry Potter";
$book->RATING = 9;
$id = $redbean->store( $book );
echo "got id = $id";
$b=$redbean->load("book", $id);
print_r($b);
$b->RATING = 8;
$redbean->store($b);
echo $redbean->count("book");

R::configureFacadeWithToolbox($toolbox);
$p = R::dispense("page");
$p->name = "hi";
R::associate($b,$p);



**/

















